Subject: RE: IPP> Consensus on sending our drafts to the IESG

From: Paul Moore <[email-masked]>
Date: Fri, 6 Feb 1998 18:25:54 -0800

MS & HP will state to the IESG our concerns with the current design (just as
anybody in the Internet comunity can).

Having said that - we will implement what the IESG ratifies. It is our aim
to have maximum interoperability, not to divide the world into different
camps - that would be a war we can all do without.

Our intent is purely to do the right thing both for the short term and the
long term. We saw IPP as an opportunity for printing to 'do it right' from
day 1 as opposed to always having to compromise on other solutions (SNMP,
LPR/LPD, ...). Our view is that spending a little more time on it would
provide a more flexible, future-proof solution. This argument did not win
the day - instead we did a 'hey its good enough, lets ship it' - so be it
(although, as I stated before, we will raise our objection to the IESG
level).

> -----Original Message-----
> From:	Wagner, William [SMTP:[email-masked]]
> Sent:	Friday, February 06, 1998 2:13 PM
> To:	[email-masked]
> Subject:	RE: IPP> Consensus on sending our drafts to the IESG
> 
> The questions voiced by Jim Walker, and Jay's addition are most
> disheartening. It is not because these are new concerns but because
> these things have been gone over and over during the course of this
> working group's life. Yes, to some people compromise is a dirty word;
> and the current specification represents very much compromise on
> everyone's part. In the last analysis however, the deciding factor
> should not be whether one or another favorite approach is used, but:
> does what is specified work? does it do what it was intended to do? is
> it producable and deployable?
> 
> Jay's very practical concern about  can a printing specification not
> implemented by Microsoft and HP ever succeed must be considered.
> Microsoft and HP have a history of pushing through their "alternate"
> solutions just as a specification nears completion. I would have thought
> that their extensive participation and the previous round of compromises
> intended to incorporate the ideas of these two giants would have may
> unnecessary this "end-play". Apparently, it has not.
> 
> The group can continue, and can put into effect a working protocol for
> inter/intra net printing. It can do this with or without IESG sanction
> and with or without Microsoft/HP participation. The question of whether
> this is a viable action is one for marketeers, not engineers.
> 
> W. A. Wagner (Bill Wagner)
> OSICOM/DPI
> 
> > -----Original Message-----
> > From:	Jay Martin [SMTP:[email-masked]]
> > Sent:	Friday, February 06, 1998 2:53 PM
> > To:	[email-masked]
> > Cc:	[email-masked]
> > Subject:	Re: IPP> Consensus on sending our drafts to the IESG
> > 
> > I would like to go on record as sharing many (if not most) of
> > the views and comments Jim Walker has posted.
> > 
> > Given the current "culture" that has seemingly developed within
> > the IPP group, Jim should be commended on being so brave as to
> > suggest some of the views that some may describe as "nay-saying".
> > 
> > I must admit that I am a member of the group Jim refers to in:
> > 
> > >         "We know that this draft will get rejected anyways, so
> > >         why don't we send it in, collect all of the comments at
> > >         one time, and in the meantime we can think some more
> > >         about XML".
> > 
> > While I had strongly proposed that the current drafts be submitted
> > as-is for IETF review, the fact is, I really don't like the
> > IPP protocol as it is currently defined.  (Wow, I said it.
> > Now I feel better... ;-)
> > 
> > One final note: whether IPP (as currently defined) is better or
> > worse than XML is really a useless discussion, IMHO.
> > 
> > Without Microsoft's aggressive support, any *pervasive* deployment
> > of an Internet-like printing protocol will likely fail within the
> > general domain.  If Microsoft balks at IPP v1.0 (and they surely
> > have made this comment, repeatedly!), then does anyone actually
> > believe they will deploy it?
> > 
> > I have longed for the day in which the Printer Industry as a whole
> > would stand up, band together, and produce something in concert
> > with the sum of the industry's players.  But, after waiting some
> > five years for this act to occur, I now find that this belief is
> > but a pipe dream.
> > 
> > Let's face it.  As long as the printer industry continues to gate
> > itself on the progress and initiative of Microsoft and HP, then
> > true innovation deployed on a global scale--in which the efforts
> > are conducted on an honestly "level playing field"--is likely
> > to NEVER happen, at least not in our lifetime.  (Of course, the
> > Department of Justice could change all of that... ;-)
> > 
> > I would like to publicly challenge Microsoft to put forth an
> > "Internet printing" proposal in which it can demonstrate true
> > openness for allowing the printer industry to participate in
> > it's development and deployment.
> > 
> > I, for one, have no problem in working within an environment
> > that has a "benevolent dictator".  After all, my company exists
> > to make products and profit from that effort.  Having a single
> > "Master" of a given effort is fine...so long as the Master is
> > open and honest with its "serfs".
> > 
> > Thanks for letting me get this off my chest.
> > 
> > 	...jay
> > 
> > ----------------------------------------------------------------------
> > --  JK Martin               |  Email:   [email-masked]          --
> > --  Underscore, Inc.        |  Voice:   (603) 889-7000              --
> > --  41C Sagamore Park Road  |  Fax:     (603) 889-2699              --
> > --  Hudson, NH 03051-4915   |  Web:     http://www.underscore.com   --
> > ----------------------------------------------------------------------
> > 
> > 
> > James Walker wrote:
> > > 
> > > Roger K Debry wrote:
> > > >
> > > > Not having been in Maui, I'd be interested in what
> > > > you believe the "many other" issues are.
> > > 
> > > Sorry about the delay in the response...
> > > 
> > > There were several other issues that were discussed, some of which
> > > I thought came up during the phone conference (alas, we all know
> > > how well that technology worked :-).
> > > 
> > > At any rate here are some that I remember (not meant to be an
> > > exhaustive list)...
> > > 
> > > o   Using a new HTTP method rather than overloading POST.
> > >         Nuff said.
> > > 
> > > o   Concern over using HTTP at all... there was a rumor going
> > >         around that the IESG was poised to reject the current
> > >         IPP drafts because HTTP was being used as the protocol.
> > >         In fact, part of the discussion was along the lines of
> > >         "We know that this draft will get rejected anyways, so
> > >         why don't we send it in, collect all of the comments at
> > >         one time, and in the meantime we can think some more
> > >         about XML".
> > > 
> > >         There also seemed to be some underriding current of
> > >         uneasiness from some of the group regarding HTTP.
> > >         This is just a subjective opinion of mine, but there
> > >         were comments made like "now, if we had just used a
> > >         simple socket-level protocol..."
> > > 
> > > o   IPP as an embedded printer protocol versus a print server
> > >         protocol.  There was a lot of discussion about whether
> > >         we are trying to accomplish too much by having one
> > >         protocol for both the embedded printer and the print
> > >         server.  For example, there is a natural tension between
> > >         the space requirements that the embedded printer crowd
> > >         (rightfully) defends, and the "elegance" and
> > >         "extensibility" arguments that the print server crowd
> > >         espouses.  I think that the XML discussion, as well as
> > >         the original text versus binary protocol discussion from
> > >         over a year ago, are valid examples of this tension.
> > > 
> > > o   IPP versus SNMP.  Along the same lines of some of the issues
> > >         above were discussions about overlap between IPP and SNMP.
> > >         There was at least one suggestion that IPP should perhaps
> > >         just be a job submission (and cancellation?) protocol,
> > >         and use the existing Printer and Job Monitoring MIBs for
> > >         determining printer and job status.
> > > 
> > >         I was also concerned about comments from at least one
> > >         representative from a large printer vendor that indicated
> > >         very little interest in IPP as a whole.  "If we already
> > >         have a way to get jobs in the printer (using, say, a
> > >         simple bi-directional TCP connection) and a way to monitor
> > >         those jobs, as well as the printer (SNMP), what good does
> > >         IPP do for us?"
> > > 
> > > These are just some random recollections.  I do not mean to be
> > > a gloom-and-doom'er, but I did want to document some of the
> > > observations that I made from my seat.
> > > 
> > > ...walker
> > > 
> > > --
> > > Jim Walker <[email-masked]>
> > > System Architect/DAZEL Wizard
> > > DAZEL Corporation, Austin, TX

---

From: Jay Martin <[email-masked]>
Date: Sat, 07 Feb 1998 13:15:38 -0500

Paul,

> MS & HP will state to the IESG our concerns with the current
> design (just as anybody in the Internet comunity can).

And rightly so.  We all look forward to seeing your concerns posted
to the IESG, where a larger domain of reviewers may be able to shed
additional light on this situation.

> Having said that - we will implement what the IESG
> ratifies. It is our aim to have maximum interoperability,
> not to divide the world into different camps - that would
> be a war we can all do without.

This is certainly good news.  We all needed to hear these "official"
words from Microsoft.  Whether the protocol/model is good or bad is
not nearly as important as solidarity, given the critical mass
nature of our efforts.

Are you able to speak on behalf of HP, or should a similar statement
be made from an HP representative?

> Our intent is purely to do the right thing both for the
> short term and the long term. We saw IPP as an opportunity
> for printing to 'do it right' from day 1 as opposed to
> always having to compromise on other solutions (SNMP,
> LPR/LPD, ...).

Now this paragraph is totally confusing to me, Paul.  I vividly
recall back at the May '97 IPP meeting (San Diego) the group
explicitly discussed the notion of "something quick vs. something
long term" in terms of whether to go "Web/HTTP" vs. a "simple,
socket-based approach".

Recall that meeting?  It was the meeting in which I was supposed
to get up and make "one last pitch" for a simple, socket-based
approach" using the CPAP protocol as an example starting point.
Having sensed the group's strong desire to leverage HTTP server
technology (based on assumptions that have since proven to be
totally *false* and unworkable), I decided to be "politically
correct" and not give a CPAP presentation, so as not to appear
as if I were "rocking the boat".  (I have since regretted that
decision.)

The official minutes for this meeting, however, did not detail
some of the critical statements made during this discussion.
(ftp://ftp.pwg.org/pub/pwg/ipp/minutes/ipp-0597.txt)

What did happen was that Carl-Uno took a vote from the group
as to the desired direction to proceed.  The vote was in
favor of an HTTP approach (by quite a large margin).

Those who attended that meeting should recall that you
surprised all those in attendance by voting for BOTH
approaches!  To say the least, I was quite shocked and
asked you why you voted both ways.

Your reply was something like this (not your exact words,
but pretty close for all intents and purposes):

  If we wanted a real, long-term useful printing protocol,
  then we would of course design a protocol using a simple
  socket-based approach.  Such a protocol would allow us to
  do much more than just job submission, but could also allow
  us to effect critical management functions using the same
  protocol.  However, since the world appears to strongly
  desire some sort of Web-based interface, let's just develop
  a simple HTTP-based submission protocol.  Afterwards, we
  can then address a more suitable protocol usable in the
  long-term.

I LOVED THIS STATEMENT.  It seemed so pragmatic and clearly
thought out that I immediately jumped on the bandwagon to
develop a *simple* HTTP-based protocol, hoping (of course)
that the effort would not be long and drug out, and that
we all could finish the effort in the originally intended
schedule.

>From what I could see, it was in my best interest to help
complete the HTTP-based effort as quickly as possible so
as to be able to more quickly move on to the development
of a REAL, long-term protocol.

However, as time moved on, more and more people started
to view IPP as both an INTERnet protocol *and* and INTRAnet
protocol.  And this is where the real disaster strikes, IMHO.

So now, when you say:

> Our intent is purely to do the right thing both for the
> short term and the long term. We saw IPP as an opportunity
> for printing to 'do it right' from day 1 as opposed to
> always having to compromise on other solutions (SNMP,
> LPR/LPD, ...).

This appears to be a complete reversal of your great comments
made to the group back in May in San Diego.  In San Diego,
you implied that IPP would serve as an interim protocol, as
anything HTTP-based would not easily allow for the kind of
long-term printing protocol the world really needs, at least
not within enterprise environments.

This is truly disappointing.  And I know for a fact I am not
alone in this belief.

	...jay

---

From: [email-masked]
Date: Tue, 10 Feb 1998 16:05:32 -0700

In response to Jay's query....
     
     Yes, Hewlett-Packard agrees with Paul Moore in that we will implement 
     what the IESG ratifies, and our aim, as well, is to promote 
     interoperability.  The intent of IPP is to enhance and standardize 
     internet printing, not to create a political battle between companies.

     Kris Schoff
     Hewlett-Packard

______________________________ Reply Separator _________________________________
Subject: Re: IPP> Consensus on sending our drafts to the IESG
Author:  Non-HP-jkm ([email-masked]) at HP-Boise,mimegw7
Date:    2/7/98 10:15 AM

Paul,